POJ--4973--A simple simulation problem.【线段树】

链接:http://acm.hdu.edu.cn/showproblem.php?pid=4973

题意:有一段数字,长度n,数字为1~n,有两种操作,第一种是使区间[l,r]内的所有数字变成两个,长度n随之增大,第二种操作是查询区间[l,r]中相同的数字最多有多少个。

思路:比赛时扫了一眼,看区间要扩大,没有细想就觉得线段树做不了,而且当时没有人交这道题就没管了,然后看解题报告居然真的是线段树。。。觉得自己好傻逼。因为只有n种数字,n最大50000,线段树维护3个值:第i个数字有多少个(sum数组)、区间最多相同数字(maxm数组)、延迟更新标记(add数组),这道题只要想到维护第i个数字的个数,就好做多了,难的地方在于区间[l,r]不能像普通线段树那样了,得根据数字的个数确定区间,然后如果找到了当前区间在[l,r]范围内,则可以进行区间更新,否则应当进行单点更新。

这道题树状数组也可以做,要比线段树简洁的多。

#include<cstring>
#include<string>
#include<fstream>
#include<iostream>
#include<iomanip>
#include<cstdio>
#include<cctype>
#include<algorithm>
#include<queue>
#include<map>
#include<set>
#include<vector>
#include<stack>
#include<ctime>
#include<cstdlib>
#include<functional>
#include<cmath>
using namespace std;
#define PI acos(-1.0)
#define MAXN 50100
#define eps 1e-7
#define INF 0x7FFFFFFF
#define LLINF 0x7FFFFFFFFFFFFFFF
#define seed 131
#define MOD 1000000007
#define ll long long
#define ull unsigned ll
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1

ll sum[MAXN<<2],maxm[MAXN<<2],add[MAXN<<2];
ll n,m;
void pushup(ll rt){
    sum[rt] = sum[rt<<1] + sum[rt<<1|1];
    maxm[rt] = max(maxm[rt<<1],maxm[rt<<1|1]);
}
void pushdown(ll rt){
    if(add[rt]>1){
        sum[rt<<1] *= add[rt];
        sum[rt<<1|1] *= add[rt];
        maxm[rt<<1] *= add[rt];
        maxm[rt<<1|1] *= add[rt];
        add[rt<<1] *= add[rt];
        add[rt<<1|1] *= add[rt];
        add[rt] = 1;
    }
}
void build(ll l,ll r,ll rt){
    add[rt] = 1;
    if(l==r){
        sum[rt] = maxm[rt] = 1;
        return ;
    }
    ll m = (l+r)>>1;
    build(lson);
    build(rson);
    pushup(rt);
}
void update(ll x,ll L,ll R,ll l,ll r,ll rt){
    if(L<=x&&x+sum[rt]-1<=R){
        sum[rt] *= 2;
        maxm[rt] *= 2;
        add[rt] *= 2;
        return ;
    }
    if(l==r){
        if(x<=L)    sum[rt] += min(R,x+sum[rt]-1)-L+1;
        else    sum[rt] += R-x+1;
        maxm[rt] = max(sum[rt],maxm[rt]);
        return ;
    }
    pushdown(rt);
    ll m = (l+r)>>1;
    ll p = x+sum[rt<<1]-1;
    if(L<=p)    update(x,L,R,lson);
    if(p<R)     update(p+1,L,R,rson);
    pushup(rt);
}
ll query(ll x,ll L,ll R,ll l,ll r,ll rt){
    if(L<=x&&x+sum[rt]-1<=R){
        return maxm[rt];
    }
    if(l==r){
        if(x<=L)    return min(R,x+sum[rt]-1)-L+1;
        else    return R-x+1;
    }
    pushdown(rt);
    ll res = 0;
    ll m = (l+r)>>1;
    ll p = x+sum[rt<<1]-1;
    if(L<=p)    res = max(res,query(x,L,R,lson));
    if(p<R)     res = max(res,query(p+1,L,R,rson));
    return res;
}
int main(){
    ll t,i,j,l,r,k=1;
    char str[5];
    scanf("%I64d",&t);
    while(t--){
        scanf("%I64d%I64d",&n,&m);
        build(1,n,1);
        printf("Case #%I64d:\n",k++);
        while(m--){
            scanf("%s%I64d%I64d",str,&l,&r);
            if(str[0]=='D') update(1,l,r,1,n,1);
            else    printf("%I64d\n",query(1,l,r,1,n,1));
        }
    }
    return 0;
}
时间: 2024-10-06 15:32:17

POJ--4973--A simple simulation problem.【线段树】的相关文章

hdu 4973 A simple simulation problem.(线段树)

http://acm.hdu.edu.cn/showproblem.php?pid=4973 有两种操作 D l r 将[l,r]区间翻倍 Q l r询问[l,r]中相同数字出现的最多次数 比赛的时候脑子太乱了,没有想到怎么做.发现每次翻倍序列的长度都在变化,区间对应的数也在变,没有思路. 但是静下心来想一想,思路还是挺清晰的. 无论怎么翻倍,序列中的数都是连续的,范围是1~n.可以拿一个数组来记录每个数出现的次数,当更新或询问区间[l,r]时,可以利用其前缀和找到区间[l,r]对应的数字分别是

HDU4973A simple simulation problem.(线段树,区间更新)

A simple simulation problem. Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 330    Accepted Submission(s): 132 Problem Description There are n types of cells in the lab, numbered from 1 to n.

HDU-4937-A simple simulation problem.(线段树)

Problem Description There are n types of cells in the lab, numbered from 1 to n. These cells are put in a queue, the i-th cell belongs to type i. Each time I can use mitogen to double the cells in the interval [l, r]. For instance, the original queue

HDU4973:A simple simulation problem.(线段树)

Problem Description There are n types of cells in the lab, numbered from 1 to n. These cells are put in a queue, the i-th cell belongs to type i. Each time I can use mitogen to double the cells in the interval [l, r]. For instance, the original queue

hdu - 4973 - A simple simulation problem.(线段树单点更新 + 区间更新)

题意:初始序列 1, 2, ..., n,m次操作(1 <= n,m<= 50000),每次操作可为: D l r,将区间[l, r]中的所有数复制一次: Q l r,输出区间[l, r]中同一数字个数的最大值. (0 <= r – l <= 10^8, 1 <= l, r <= 序列元素个数) 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4973 -->>因为区间内数字是依次递增的,所以可以以数字为叶建线段

ZOJ 3686 A Simple Tree Problem(线段树)

A Simple Tree Problem Time Limit: 3 Seconds      Memory Limit: 65536 KB Given a rooted tree, each node has a boolean (0 or 1) labeled on it. Initially, all the labels are 0. We define this kind of operation: given a subtree, negate all its labels. An

bzoj 3489 A simple rmq problem - 线段树

Description 因为是OJ上的题,就简单点好了.给出一个长度为n的序列,给出M个询问:在[l,r]之间找到一个在这个区间里只出现过一次的数,并且要求找的这个数尽可能大.如果找不到这样的数,则直接输出0.我会采取一些措施强制在线. Input 第一行为两个整数N,M.M是询问数,N是序列的长度(N<=100000,M<=200000) 第二行为N个整数,描述这个序列{ai},其中所有1<=ai<=N 再下面M行,每行两个整数x,y, 询问区间[l,r]由下列规则产生(OIER

HDU-4973-A simple simulation problem.(二分+树状数组)

Problem Description There are n types of cells in the lab, numbered from 1 to n. These cells are put in a queue, the i-th cell belongs to type i. Each time I can use mitogen to double the cells in the interval [l, r]. For instance, the original queue

POJ - 2528 - Mayor&#39;s posters 【线段树+离散化+补点】

http://poj.org/problem?id=2528 #include <cstdio> #include <iostream> #include <set> #include <cstring> #include <string> #define left rt<<1 #define right rt<<1|1 using namespace std; const int MAXN = 32768 + 5; in

POJ 1436 Horizontally Visible Segments(线段树建图+枚举)

题目连接:http://poj.org/problem?id=1436 题意:给一些线段,每个线段有三个值y1, y2, x代表起点为(x, y1),终点为(x, y2)的线段.当从一个线段可以作水平线到另一个线段并且不穿过其他线段时,就称这两个线段时水平可见的.当三个线段可以两两水平可见,就称为形成一个线段三角.问:在这些线段中有多少个这样的线段三角? 分析:可以把每条线段看做是一个点,如果它和其他线段是水平可见的,就将这两个点相连,由于是无向图,就是你能看到我,我也能看到你,所以需要连接两次